/*
  Copyright (C) MOXA Inc. All rights reserved.
  This software is distributed under the terms of the
  MOXA License.  See the file COPYING-MOXA for details.
*/
/*******************************************************************************
File Name : keypad.c

Description :
	The program demo how to code Keypad pragram on UC.

Usage :
	1.Compile this file and execute on UC7000 series.
	2.When you press the F1~5 key of UC,the screen will show
	  the key that you pressed.
History :
	Version		Author		Date		Comment
	1.0		Hank		01-15-2004	Wrote it
*******************************************************************************/
#include	<stdio.h>
#include	<stdlib.h>
#include	<fcntl.h>
#include	<errno.h>
#include	<termios.h>
#include	<time.h>
#include	<errno.h>
#include	<moxadevice.h>

#include	"keypad.h"

int main(int argc, char * argv[])
{
	int	key;
#if (defined DA660_661_662_663)
	char key_name[4][10] = {"KEY_MENU","KEY_SEL","KEY_DOWN","KEY_UP"};
#elif (defined UC7410_7420)
	char key_name[5][10] = {"F1","F2","F3","F4","F5"};

	printf("\nPress F5 to exit...\n");	
#endif

	KeypadInit();

	while( 1) 
	{
		usleep( 100);
		if( !KeypadHasPress())
			continue;
		key= KeypadGetKey();
		printf("The key you press is %s\n", key_name[key]);
		
		if ( key == 4 ) 
			break;
	}

	return 0;
}
