/*
  Copyright (C) MOXA Inc. All rights reserved.
  This software is distributed under the terms of the
  MOXA License.  See the file COPYING-MOXA for details.
*/
#ifndef KEYPAD_H
#define KEYPAD_H

#include <stdlib.h>
#include <fcntl.h>
#include <sys/time.h>
#include <moxadevice.h>

// Defined for DA-661/662/663-16-LX
#define KEY_MENU        0
#define KEY_SEL         1
#define KEY_DOWN        2
#define KEY_UP          3

#define IOCTL_KEYPAD_HAS_PRESS  1
#define IOCTL_KEYPAD_GET_KEY    2
#define IOCTL_KEYPAD_SOUND_SET  3


int	KeypadInit();
int	KeypadHasPress();
int	KeypadGetKey();

/* Get the key from keypad
   *key:
     KEY_MENU           0
     KEY_SEL            1
     KEY_DOWN                   2
     KEY_UP             3
   return:
     0 : success
     -1: fail
 */
int     wait_keypad_key(int *key);
#endif

