/*
  Copyright (C) MOXA Inc. All rights reserved.
  This software is distributed under the terms of the
  MOXA License.  See the file COPYING-MOXA for details.
*/
/*******************************************************************************
File Name:	link.c

Description:
	Ethernet link status detection.

Usage:
	Run it on target (UC-7400/DA-660/UC-7400+/DA-661/662/663-LX series).

History:
	Version		Author		Date		Comment
	1.0		Jared Wu.	06-23-2008	Wrote it.
*******************************************************************************/
#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/socket.h>
#include <string.h>
#include <netinet/in.h>
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <linux/if.h>
#include <errno.h>
typedef unsigned char u8;
typedef unsigned short u16;
typedef unsigned int u32;
typedef unsigned long u64;
#include	<linux/ethtool.h>
#include	<linux/sockios.h>

#define	PORT_NUM	3

int main()
{
	int i, j, socketfd[ PORT_NUM];
#ifdef UC7400
	char devprefix[]= "ixp";
#else
	char devprefix[]= "eth";
#endif
	char devname[ 10];

	struct sockaddr_in local;
	struct sockaddr_in from;
	int fromlen =sizeof(from);
	struct ifreq ifr;
	fd_set readfds;
	int tmpfd, maxfd= -1;
	struct ethtool_value edata ;		/* Struct network tool,support only by
						 * exiting device driver */
	
	while( 1)
	{
		for( i= 0; i< PORT_NUM; i++)	// eth0/ixp0 & eth1/ixp1
		{
			socketfd[ i]=socket(AF_INET,SOCK_DGRAM,IPPROTO_UDP);
			sprintf( devname, "%s%d", devprefix, i);
			strcpy( ifr.ifr_name, devname);

			/* Testing RJ45 power status */

			edata.cmd = ETHTOOL_GLINK ;
			ifr.ifr_data = (char *)&edata ;
			if (ioctl(socketfd[i], SIOCETHTOOL, &ifr) == -1)
			       	printf("ETHTOOL_GLINK failed: %s\n", strerror(errno));

			edata.data ? printf("%s Link power on\n",devname) : printf("%s Link power lost\n",devname) ;
		}
		sleep( 1);
	}
	close(socketfd[ 0]);
	close(socketfd[ 1]);

	return 0;
}

