/*
  Copyright (C) MOXA Inc. All rights reserved.
  This software is distributed under the terms of the
  MOXA License.  See the file COPYING-MOXA for details.
*/

/*
 * History:
 * Date		Author			Comment
 * 06-15-2004	Victor Yu.		Create it.
 * 09-16-2004	Victor Yu.		To add MoxaDog API
 */
#include	<stdio.h>
#include	<stdlib.h>
#include	<fcntl.h>
#include	"moxadevice.h"

// following for sWatchDog implement
#define IOCTL_SWATCHDOG_ENABLE	1
#define IOCTL_SWATCHDOG_DISABLE	2
#define IOCTL_SWATCHDOG_GET	3
#define IOCTL_SWATCHDOG_ACK	4
int	swtd_open(void)
{
	return open("/dev/swtd", O_RDWR);
}

int	swtd_enable(int fd, unsigned long time)
{
	return ioctl(fd, IOCTL_SWATCHDOG_ENABLE, &time);
}

int	swtd_disable(int fd)
{
	return ioctl(fd, IOCTL_SWATCHDOG_DISABLE, NULL);
}

int	swtd_get(int fd, int *mode, unsigned long *time)
{
	struct {
		int		mode;
		unsigned long	time;
	} nowset;
	int			ret;

	ret = ioctl(fd, IOCTL_SWATCHDOG_GET, &nowset);
	*mode = nowset.mode;
	*time = nowset.time;
	return ret;
}

int	swtd_ack(int fd)
{
	return ioctl(fd, IOCTL_SWATCHDOG_ACK, NULL);
}

int	swtd_close(int fd)
{
	return close(fd);
}

